<!--- postquery loop handles post processing tasks --->
<br><br>BEGIN POSTQUERY LOOP<br>

<cfloop from="1" to="#ListLen(ValueList(Schema.FieldName))#" index="i">
  <cfif Schema.DataType[i] eq "varchar">
  	<cfif ListLen(Schema.Options[i],":") gte 2 and ListGetAt(Schema.Options[i],1,":") eq "Calculate" and Schema.Editable[i] eq 0>
  		<!--- field has a formula and is not editable - needs to be calculated and stored --->
  		<cfquery name="UpdateByCalculation" dataSource="#Application.psDataSource#">
  		update #TableName# set #Schema.FieldName[i]# = '#Evaluate("form." & Schema.FieldName[i])#' where ID = #RecordID#
  		</cfquery>
  	</cfif>
  	<cfif Schema.Encrypt[i] eq 1 and Evaluate("form." & Schema.FieldName[i]) neq "">
  		<cfset EncryptedValue = Encrypt(Evaluate("form." & Schema.FieldName[i]),EncKey,EncAlgorithm)>
  		<cfquery name="Encrypt" dataSource="#Application.psDataSource#">
  		update #TableName# set #Schema.FieldName[i]# = '#EncryptedValue#' where ID = #RecordID#
  		</cfquery>
  	</cfif>
  	
  	<cfelseif Schema.DataType[i] eq "int">
  	
  	<cfelseif Schema.DataType[i] eq "money">
  	<cfif ListLen(Schema.Options[i],":") gte 2 and ListGetAt(Schema.Options[i],1,":") eq "Calculate" and Schema.Editable[i] eq 0>
  		<!--- field has a formula and is not editable - needs to be calculated and stored --->
  		<cfquery name="UpdateByCalculation" dataSource="#Application.psDataSource#">
  		update #TableName# set #Schema.FieldName[i]# = #Val(Evaluate("form." & Schema.FieldName[i]))# where ID = #RecordID#
  		</cfquery>
  	</cfif>
  	
  	<cfelseif Schema.DataType[i] eq "text" and Evaluate("form."&Schema.FieldName[i]) neq "">
  	
  	<cfelseif Schema.DataType[i] eq "list">
  	<!--- support for grouplist, other subtypes may follow --->
  	<cfset NumberOfColumns = ListGetAt(Schema.Options[i],1)>
  	<cfset SourceField = ListGetAt(Schema.Options[i],2)>
  	<cfset SourceIDList = ListGetAt(Schema.Options[i],3)>
  	<cfset SourceTable = ListGetAt(Schema.Options[i],4)>
  	<cfquery name="Groups" dataSource="#Application.psDataSource#">
  	select ID,#SourceField#,#SourceIDList# from #SourceTable# order by #SourceField#
  	</cfquery>
  	<cfloop query="Groups">
  		<cfset CurrentGroupIDList = Evaluate("Groups.#SourceIDList#")>
  		<cfif IsDefined("form.group_#Groups.ID#")>
  			<cfif not ListFInd(CurrentGroupIDList,RecordID)>
  				<cfquery name="UpdateGroup" datasource="#Application.psDataSource#">
  				update #SourceTable# set #SourceIDList# = '#ListAppend(CurrentGroupIDList,RecordID)#' where ID = #Groups.ID#
  				</cfquery>
  			</cfif>
  			<cfelse>
  			<cfif ListFInd(CurrentGroupIDList,RecordID)>
  				<cfquery name="UpdateGroup" datasource="#Application.psDataSource#">
  				update #SourceTable# set #SourceIDList# = '#ListDeleteAt(CurrentGroupIDList,ListFInd(CurrentGroupIDList,RecordID))#' where ID = #Groups.ID#
  				</cfquery>
  			</cfif>
  		</cfif>
  	</cfloop>
  </cfif>
</cfloop>

<br>END POSTQUERY LOOP

<!--- END post-query loop -- upload files --->

