this component will be used to
-	initialize
	- init(): create padsite's global variables (init calls createTables() if a schema table is not found)
		- createTables(): create all the initial/system tables (setup)
- facilitate ongoing management of the schema
	- psGetSchema(table)
  -	psCreateTable(table)
  -	psRenameTable(table,new name)
  <!--- - psRequeueTable(name) --->
  -	psDropTable(table)
  - psCreateColumn(table,column,type,etc)
  - psRenameColumn(table,column,new name) -assumed to be same type
  - psDropColumn(table,column)
  - psInsertColumn(table,column,type,etc)
  - psPage()
	


<!--- Development Notes:

add a library of page-generating modules (xml descriptions for pagegen) and table-building queries

need to add a "save search as a group" function

need initial version of adminpages.cfm to get created automatically (or be packaged with framework?)

preference setting for basic or advanced interface (preference color settings also?)

how to integrate table builder with form builder - need module for selecting which fields to display
also need to have form builder tied to shopping cart this could be through a "product" field subtype

add money,float to list of StandardDataTypes
add formula to NonStandardDataTypes

--->



<component>


<cffunction name="psInit">
	<cfreturn true>
</cffunction>


<cffunction name="psGetSchema" returnType="query">
	<cfargument name="TableName" required="true">
	<cfquery name="local.Schema" datasource="#Application.psDataSource#">
	select * from #Application.psSchemaTable# where TableName = '#arguments.TableName#' order by Queue
	</cfquery>
	<cfreturn local.Schema>
</cffunction>


<cffunction name="psHasVisibleQueueField" returnType="boolean">
	<cfargument name="TableName" required="true">
	<cfquery name="local.HasVisibleQueueField" dataSource="#Application.psDataSource#">
	select 1 from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and FieldName = 'Queue' and Display = 1
	</cfquery>
	<cfreturn IIf(local.HasVisibleQueueField.RecordCount,DE(true),DE(false))>
</cffunction>


<cffunction name="psHasDateCreatedField" returnType="boolean">
	<cfargument name="TableName" required="true">
	<cfquery name="local.HasDateCreatedField" dataSource="#Application.psDataSource#">
	select 1 from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and FieldName = 'DateCreated'
	</cfquery>
	<cfreturn local.HasDateCreatedField>
</cffunction>


<cffunction name="psHasDateModifiedField" returnType="boolean">
	<cfargument name="TableName" required="true">
	<cfquery name="local.HasDateModifiedField" dataSource="#Application.psDataSource#">
	select 1 from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and FieldName = 'DateModified'
	</cfquery>
	<cfreturn local.HasDateModifiedField>
</cffunction>


<cffunction name="psHasEmailAddressField" returnType="boolean">
	<cfargument name="TableName" required="true">
	<cfquery name="local.HasEmailAddressField" dataSource="#Application.psDataSource#">
	select ID from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and Subtype = 'email'
	</cfquery>
	<cfreturn local.HasEmailAddressField.RecordCount>
</cffunction>


<cffunction name="psForeignKeys" returnType="query">
	<cfargument name="TableName" required="true">
	<cfquery name="local.ForeignKeys" dataSource="#Application.psDataSource#">
	select ID,FieldName,Options from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and Subtype = 'foreignkey';
	</cfquery>
	<cfreturn local.ForeignKeys>
</cffunction>


<cffunction name="psGetFilterMenu" returnType="struct" hint="check for padsite filter menu - returns different variables depending on filter type - used by reporter">
	<cfargument name="TableName" required="true">
	<cfset local.FilterMenu.Success = false>
	<cfset local.FilterMenu.Display = false>
	<!--- check for filter --->
	<cfquery name="local.FilterMenu.Query" datasource="#Application.psDataSource#">
	select ID,Subtype,Options from #Application.psSchemaTable# where TableName = '#arguments.TableName#' and Datatype = 'filter'
	</cfquery>
	<cfif local.FilterMenu.Query.RecordCount eq 1>
	  <cfset local.FilterMenu.Display = true>
	  <cfset local.FilterMenu.FilterOptionList = local.FilterMenu.Query.Options>
	  <cfif local.FilterMenu.Query.Subtype eq "filter_foreignkey">
	  	<!--- 1,SectionName,mvcDev_PageSections,mvcDev_PageSectionsID --->
	  	<cfset local.FilterMenu.FilterFieldName = ListGetAt(local.FilterMenu.FilterOptionList,2)>
	  	<cfset local.FilterMenu.FilterTableName = ListGetAt(local.FilterMenu.FilterOptionList,3)>
	  	<cfset local.FilterMenu.FilterForeignKey = ListGetAt(local.FilterMenu.FilterOptionList,4)>
	  	<!--- <cfelseif local.FilterMenu.Query.Subtype eq "filter_group">
	  	<cfset local.FilterMenu.FilterFieldName = ListGetAt(local.FilterMenu.FilterOptionList,2)>
	  	<cfset local.FilterMenu.FilterIDList = ListGetAt(local.FilterMenu.FilterOptionList,3)>
	  	<cfset local.FilterMenu.FilterTableName = ListGetAt(local.FilterMenu.FilterOptionList,4)> --->
	  	<cfelseif local.FilterMenu.Query.Subtype eq "filter_string">
	  	<cfset local.FilterMenu.FilterFieldName = ListGetAt(local.FilterMenu.FilterOptionList,2)>
	  	<cfset local.FilterMenu.FilterTableName = ListGetAt(local.FilterMenu.FilterOptionList,3)>
	  	<cfelse>
	  	<cfabort showError="#local.FilterMenu.Query.Subtype# not currently supported in psGetFilterMenu">
	  </cfif>
	  <cfelseif local.FilterMenu.Query.RecordCount gt 1>
	  <cfabort showError="too many filters specified for report - only one filter per table supported">
	</cfif>
	<cfset local.FilterMenu.Success = true>
	<cfreturn local.FilterMenu>
</cffunction>


<!--- <cffunction name="psHasParentTable" returnType="boolean">
	<cfreturn false>
</cffunction> --->


<!--- <cffunction name="psDisplayParentSendMail" returnType="struct" hint="check for related tables where subtype is email - not currently used">
	<cfargument name="ParentTable" required="true">
  <cfquery name="local.ParentHasEmailAddressField" dataSource="#Application.psDataSource#">
  select ID from #Application.psSchemaTable# where TableName = '#ParentTable#' and Subtype = 'email'
  </cfquery>
  <cfif local.ParentHasEmailAddressField.RecordCount gte 1>
  	<cfset local.DisplayParentSendmail = true>
  	<cfelse>
  	<cfset local.DisplayParentSendmail = false>
  </cfif>
  has parent table
</cffunction> --->


</component>